//########## Plasma Tank

//### Sound

datablock AudioProfile(gc_PlasmaTankFireSound)
{
  filename = "./plasmatankfire.wav";
  description = AudioDefault3d;
  preload = true;
};

datablock AudioProfile(gc_plasmaBallHitSound)
{
  filename = "./plasmacannonhit.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_PlasmaTankMGFireSound)
{
  filename = "./plasmatankmgfire.wav";
  description = AudioClose3d;
  preload = true;
};

datablock AudioProfile(gc_THHit1Sound)
{
  filename = "./hit1.wav";
  description = AudioClosest3d;
  preload = true;
};

datablock AudioProfile(gc_THHit2Sound)
{
  filename = "./hit2.wav";
  description = AudioClosest3d;
  preload = true;
};

//### Effects

datablock ParticleData(gc_tireParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.4 0.4 0.3";
  colors[1] = "0.2 0.2 0.2 0";
  sizes[0] = 2;
  sizes[1] = 6;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_tireEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_tireParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_engineParticle)
{
  dragCoefficient = 2;
  gravityCoefficient = -1;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0.5";
  colors[1] = "0 0 0 0.1";
  colors[2] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_engineEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 4;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_engineParticle";
  useEmitterColors = true;
};

datablock ShapeBaseImageData(gc_PlasmaTankEngineLeftImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 3;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = gc_engineEmitter;
  stateEmitterTime[0] = 1000;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};

function gc_PlasmaTankEngineLeftImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ShapeBaseImageData(gc_PlasmaTankEngineRightImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 4;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 1000;
  stateEmitter[0] = gc_engineEmitter;
  stateEmitterTime[0] = 1000;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};

function gc_PlasmaTankEngineRightImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_vehicleDamageParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = -2;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0 0 0 0";
  colors[1] = "0 0 0 0.5";
  colors[2] = "0 0 0 0";
  sizes[0] = 3;
  sizes[1] = 4;
  sizes[2] = 6;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_vehicleDamageEmitter)
{
  uiName = "";
  ejectionPeriodMS = 50;
  periodVarianceMS = 25;
  ejectionVelocity = 2;
  velocityVariance = 1;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_vehicleDamageParticle";
  useEmitterColors = true;
};

datablock ParticleData(gc_PlasmaTankFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 50;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0.5 0 1 1";
  colors[1] = "0.8 0.6 1 1";
  colors[2] = "0.3 0.1 1 0";
  sizes[0] = 0.1;
  sizes[1] = 5;
  sizes[2] = 0;
  times[9] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_PlasmaTankFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 250;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_PlasmaTankFlashParticle";
};

datablock ParticleData(gc_PlasmaTankSmokeParticle)
{
  dragCoefficient = 4;
  gravityCoefficient = 0.2;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 800;
  lifetimeVarianceMS = 400;
  textureName = "base/data/particles/cloud";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.3 0.3 0.3 1";
  colors[1] = "0.2 0.2 0.2 0.3";
  colors[2] = "0 0 0 0";
  sizes[0] = 0.5;
  sizes[1] = 2;
  sizes[2] = 5;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_PlasmaTankSmokeEmitter)
{
  uiName = "";
  ejectionPeriodMS = 6;
  periodVarianceMS = 0;
  ejectionVelocity = 30;
  velocityVariance = 20;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 20;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_PlasmaTankSmokeParticle";
};

datablock ShapeBaseImageData(gc_PlasmaTankFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "FireB";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_PlasmaTankFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "FireB";
  stateTransitionOnTimeout[1] = "Done";
  stateWaitForTimeout[1] = true;
  stateTimeoutValue[1] = 0.2;
  stateEmitter[1] = gc_PlasmaTankSmokeEmitter; 
  stateEmitterTime[1] = 0.2;

  stateName[2] = "Done";
  stateScript[2] = "onDone";
};

function gc_PlasmaTankFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_PlasmaTankTrailParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 100;
  lifetimeVarianceMS = 0;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0.5 0.1 1 0";
  colors[1] = "0.8 0.6 1 1";
  colors[2] = "0.5 0.1 1 0";
  sizes[0] = 1;
  sizes[1] = 1;
  sizes[2] = 1;
  times[0] = 0;
  times[1] = 0.5;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_PlasmaTankTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_PlasmaTankTrailParticle";
};

datablock ParticleData(gc_PlasmaTankExplosionParticle)
{
  dragCoefficient = 1;
  gravityCoefficient = 0;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 1000;
  lifetimeVarianceMS = 500;
  textureName = "base/data/particles/cloud";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0.5 0.1 1 1";
  colors[1] = "0.8 0.6 1 1";
  colors[2] = "0.5 0.1 1 0";
  sizes[0] = 15;
  sizes[1] = 3;
  sizes[2] = 1;
  times[0] = 0;
  times[1] = 0.1;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_PlasmaTankExplosionEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 10;
  velocityVariance = 0;
  ejectionOffset = 3;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_plasmaTankExplosionParticle";
};

datablock ExplosionData(gc_PlasmaTankShellExplosion)
{
  lifeTimeMS = 200;
  emitter[0] = gc_PlasmaTankExplosionEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  lightStartRadius = 10;
  lightEndRadius = 0;
  lightStartColor = "0.8 0.6 1";
  lightEndColor = "0 0 0";
  damageRadius = 5;
  radiusDamage = 200;
  impulseRadius = 5;
  impulseForce = 200;
  soundProfile = gc_plasmaBallHitSound;
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "8 8 8";
  camShakeDuration = 2;
  camShakeRadius = 20;
};

datablock ParticleData(gc_THFlashParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "./muzzle";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0 0.5 1 1";
  colors[1] = "0.6 0.8 1 1";
  colors[2] = "0.3 0.6 1 0";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.3;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_PlasmaTankMGFlashEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = -50;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 10;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_THFlashParticle";
};

datablock ShapeBaseImageData(gc_PlasmaTankMGFireImage)
{
  shapeFile = "base/data/shapes/empty.dts";
  emap = false;
  mountPoint = 1;

  stateName[0] = "FireA";
  stateTransitionOnTimeout[0] = "Done";
  stateWaitForTimeout[0] = true;
  stateTimeoutValue[0] = 0.05;
  stateEmitter[0] = gc_PlasmaTankMGFlashEmitter;
  stateEmitterTime[0] = 0.05;

  stateName[1] = "Done";
  stateScript[1] = "onDone";
};

function gc_PlasmaTankMGFireImage::onDone(%this,%obj,%slot) { %obj.unMountImage(%slot); }

datablock ParticleData(gc_THTrailParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0;
  inheritedVelFactor = 0.2;
  constantAcceleration = 0;
  lifetimeMS = 200;
  lifetimeVarianceMS = 0;
  textureName = "./muzzle";
  spinSpeed = 10;
  spinRandomMin = -50;
  spinRandomMax = 50;
  colors[0] = "0.4 0.9 1 0.5";
  colors[1] = "0.2 0.6 1 0";
  sizes[0] = 1;
  sizes[1] = 0.2;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_THTrailEmitter)
{
  uiName = "";
  ejectionPeriodMS = 4;
  periodVarianceMS = 0;
  ejectionVelocity = 0;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 89;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = false;
  particles = "gc_THTrailParticle";
};

datablock ParticleData(gc_THArchParticle)
{
  dragCoefficient = 0;
  gravityCoefficient = 0;
  inheritedVelFactor = 1;
  constantAcceleration = 0;
  lifetimeMS = 30;
  lifetimeVarianceMS = 0;
  textureName = "./arch";
  spinSpeed = 50;
  spinRandomMin = -500;
  spinRandomMax = 500;
  colors[0] = "0 0.5 1 1";
  colors[1] = "0.6 0.8 1 1";
  colors[2] = "0.3 0.6 1 0";
  sizes[0] = 0.1;
  sizes[1] = 2;
  sizes[2] = 0;
  times[0] = 0;
  times[1] = 0.3;
  times[2] = 1;
  useInvAlpha = false;
};

datablock ParticleEmitterData(gc_THArchEmitter)
{
  uiName = "";
  ejectionPeriodMS = 3;
  periodVarianceMS = 0;
  ejectionVelocity = 50;
  velocityVariance = 0;
  ejectionOffset = 0;
  thetaMin = 0;
  thetaMax = 90;
  phiReferenceVel = 0;
  phiVariance = 360;
  orientParticles = true;
  overrideAdvance = false;
  particles = "gc_THArchParticle";
};

datablock ParticleData(gc_THSmokeParticle)
{
  dragCoefficient = 8;
  gravityCoefficient = 0.5;
  inheritedVelFactor = 0;
  constantAcceleration = 0;
  lifetimeMS = 500;
  lifetimeVarianceMS = 250;
  textureName = "base/data/particles/cloud";
  spinSpeed = 0;
  spinRandomMin = -5;
  spinRandomMax = 5;
  colors[0] = "0 0.5 1 1";
  colors[1] = "0.2 0.2 0.3 1";
  colors[2] = "0.2 0.2 0.2 0";
  sizes[0] = 1;
  sizes[1] = 1.5;
  sizes[2] = 2;
  times[0] = 0;
  times[1] = 0.2;
  times[2] = 1;
  useInvAlpha = true;
};

datablock ParticleEmitterData(gc_THSmokeEmitter)
{
  uiName = "";
  lifetimeMS = 100;
  ejectionPeriodMS = 5;
  periodVarianceMS = 0;
  ejectionVelocity = 5;
  velocityVariance = 0;
  ejectionOffset = 0.5;
  thetaMin = 0;
  thetaMax = 180;
  phiReferenceVel = 0;
  phiVariance = 360;
  overrideAdvance = true;
  useEmitterColors = false;
  orientParticles = false;
  particles = "gc_THSmokeParticle";
};

datablock DebrisData(gc_THBulletDebris)
{
  shapeFile = "./bullet.dts";
  lifetime = 0.2;
  minSpinSpeed = -200;
  maxSpinSpeed = 200;
  elasticity = 0.5;
  friction = 0.2;
  numBounces = 3;
  staticOnMaxBounce = true;
  snapOnMaxBounce = true;
  fade = true;
  gravModifier = 2;
  emitters = gc_THTrailEmitter;
};

datablock ExplosionData(gc_THExplosion)
{
  lifeTimeMS = 50;
  emitter[0] = gc_THArchEmitter;
  emitter[1] = gc_THSmokeEmitter;
  faceViewer = true;
  explosionScale = "1 1 1";
  shakeCamera = true;
  camShakeFreq = "5 5 5";
  camShakeAmp = "1 1 1";
  camShakeDuration = 0.5;
  camShakeRadius = 1;
  debris = gc_THBulletDebris;
  debrisNum = 1;
  debrisPhiMin = 0;
  debrisPhiMax = 360;
  debrisThetaMin = 0;
  debrisThetaMax = 45;
  debrisVelocity = 10;
  debrisVelocityVariance = 40;
};

//### Projectile

AddDamageType("gc_PlasmaTank",'<bitmap:Add-Ons/Vehicle_Plasmatank/CI_plasmatank>%1','%2<bitmap:Add-Ons/Vehicle_Plasmatank/CI_plasmatank>%1',1,1);

datablock ProjectileData(gc_PlasmaTankShellProjectile)
{
  uiName = "";
  projectileShapeName = "";
  directDamage = 200;
  directDamageType = $DamageType::gc_PlasmaTank;
  radiusDamageType = $DamageType::gc_PlasmaTank;
  brickExplosionRadius = 5;
  brickExplosionImpact = true;
  brickExplosionForce = 50;
  brickExplosionMaxVolume = 100;
  brickExplosionMaxVolumeFloating = 100;
  impactImpulse = 200;
  particleEmitter = gc_PlasmaTankTrailEmitter;
  explosion = gc_PlasmaTankShellExplosion;
  muzzleVelocity = 200;
  verInheritFactor = 1;
  armingDelay = 0;
  lifetime = 5000;
  fadeDelay = 5000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
  hasLight = 1;
  lightRadius = 5;
  lightColor = "0.8 0.6 1";
  explodeOnDeath = 1;
};

AddDamageType("PlasmaTankMG",'<bitmap:Add-Ons/Vehicle_Plasmatank/CI_plasmatankmg>%1','%2<bitmap:Add-Ons/Vehicle_Plasmatank/CI_plasmatankmg>%1',1,1);

datablock ProjectileData(gc_PlasmaTankMGProjectile)
{
  uiName = "";
  projectileShapeName = "Add-ons/Vehicle_Plasmatank/bullet.dts";
  directDamage = 30;
  directDamageType = $DamageType::gc_PlasmaTankMG;
  radiusDamageType = $DamageType::gc_PlasmaTankMG;
  brickExplosionRadius = 0;
  brickExplosionImpact = true;
  brickExplosionForce = 30;
  brickExplosionMaxVolume = 24;
  brickExplosionMaxVolumeFloating = 24;
  impactImpulse = 1000;
  verticalImpulse = 300;
  explosion = gc_THExplosion;
  particleEmitter = gc_THTrailEmitter;
  muzzleVelocity = 150;
  verInheritFactor = 1;
  lifetime = 4000;
  fadeDelay = 2000;
  bounceElasticity = 0.5;
  bounceFriction = 0.2;
};

//### Turret & MG

datablock TSShapeConstructor(plasmatankturretDts)
{
  baseShape = "./plasmatankturret.dts";
  sequence0 = "./root.dsq root";
  sequence1 = "./root.dsq run";
  sequence2 = "./root.dsq walk";
  sequence3 = "./root.dsq back";
  sequence4 = "./root.dsq side";
  sequence5 = "./root.dsq crouch";
  sequence6 = "./root.dsq crouchRun";
  sequence7 = "./root.dsq crouchBack";
  sequence8 = "./root.dsq crouchSide";
  sequence9 = "./look.dsq look";
  sequence10 = "./root.dsq headside";
  sequence11 = "./root.dsq headUp";
  sequence12 = "./root.dsq jump";
  sequence13 = "./root.dsq standjump";
  sequence14 = "./root.dsq fall";
  sequence15 = "./root.dsq land";
  sequence16 = "./root.dsq armAttack";
  sequence17 = "./root.dsq armReadyLeft";
  sequence18 = "./root.dsq armReadyRight";
  sequence19 = "./root.dsq armReadyBoth";
  sequence20 = "./root.dsq spearready";
  sequence21 = "./root.dsq spearThrow";
  sequence22 = "./root.dsq talk";
  sequence23 = "./root.dsq death1";
  sequence24 = "./root.dsq shiftUp";
  sequence25 = "./root.dsq shiftDown";
  sequence26 = "./root.dsq shiftAway";
  sequence27 = "./root.dsq shiftTo";
  sequence28 = "./root.dsq shiftLeft";
  sequence29 = "./root.dsq shiftRight";
  sequence30 = "./root.dsq rotCW";
  sequence31 = "./root.dsq rotCCW";
  sequence32 = "./root.dsq undo";
  sequence33 = "./root.dsq plant";
  sequence34 = "./root.dsq sit";
  sequence35 = "./root.dsq wrench";
  sequence36 = "./fire.dsq fire";
};

datablock TSShapeConstructor(plasmatankmgDts)
{
  baseShape = "./plasmatankmg.dts";
  sequence0 = "./mg_root.dsq root";
  sequence1 = "./mg_look.dsq look";
  sequence2 = "./mg_fire.dsq fire";
};

datablock PlayerData(gc_PlasmaTankTurretPlayer)
{
  renderFirstPerson = true;
  emap = false;
  className = Armor;
  shapeFile = "./plasmatankturret.dts";
  cameraMaxDist = 8;
  cameraTilt = 0.261;
  cameraVerticalOffset = 2.3;
  cameraDefaultFov = 90;
  cameraMinFov = 5;
  cameraMaxFov = 120;
  aiAvoidThis = true;
  minLookAngle = -1.5708;
  maxLookAngle = 0.5;
  maxFreelookAngle = 3;
  mass = 200000;
  drag = 1;
  density = 5;
  maxDamage = 400;
  maxEnergy = 10;
  repairRate = 0.33;
  rechargeRate = 0.4;
  runForce = 1000;
  runEnergyDrain = 0;
  minRunEnergy = 0;
  maxForwardSpeed = 0;
  maxBackwardSpeed = 0;
  maxSideSpeed = 0;
  maxForwardCrouchSpeed = 0;
  maxBackwardCrouchSpeed = 0;
  maxSideCrouchSpeed = 0;
  maxUnderwaterForwardSpeed = 0;
  maxUnderwaterBackwardSpeed = 0;
  maxUnderwaterSideSpeed = 0;
  jumpForce = 0;
  jumpEnergyDrain = 0;
  minJumpEnergy = 0;
  jumpDelay = 0;
  minJetEnergy = 0;
  jetEnergyDrain = 0;
  canJet = 0;
  minImpactSpeed = 250;
  speedDamageScale = 3.8;
  boundingBox = vectorScale("4.2 4.2 1.2",4);
  crouchBoundingBox = vectorScale("4.2 4.2 1.2",4);
  pickupRadius = 0.75;
  jetEmitter = "";
  jetGroundEmitter = "";
  jetGroundDistance = 4;
  splash = PlayerSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 0.1;
  splashEmitter[0] = PlayerFoamDropletsEmitter;
  splashEmitter[1] = PlayerFoamEmitter;
  splashEmitter[2] = PlayerBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  runSurfaceAngle = 85;
  jumpSurfaceAngle = 86;
  minJumpSpeed = 20;
  maxJumpSpeed = 30;
  horizMaxSpeed = 68;
  horizResistSpeed = 33;
  horizResistFactor = 0.35;
  upMaxSpeed = 80;
  upResistSpeed = 25;
  upResistFactor = 0.3;
  footstepSplashHeight = 0.35;
  JumpSound = "";
  groundImpactMinSpeed = 10;
  groundImpactShakeFreq = "4 4 4";
  groundImpactShakeAmp = "1 1 1";
  groundImpactShakeDuration = 0.8;
  groundImpactShakeFalloff = 10;
  maxItems = 10;
  maxWeapons = 5;
  maxTools = 5;
  uiName = "";
  rideable = true;
  lookUpLimit = 0.6;
  lookDownLimit = 0.4;
  canRide = false;
  showEnergyBar = false;
  paintable = true;
  brickImage = horseBrickImage;
  numMountPoints = 1;
  mountThread[0] = "sit";
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
  useCustomPainEffects = true;
  PainHighImage = "";
  PainMidImage = "";
  PainLowImage = "";
  painSound = "";
  deathSound = "";
};

datablock PlayerData(gc_PlasmaTankMGPlayer : gc_PlasmaTankTurretPlayer)
{
  shapeFile = "./plasmatankmg.dts";
  boundingBox = "2 2 2";
  crouchBoundingBox = "2 2 2";
  uiName = "";
  mountThread[0] = "root";
};

//### Vehicle

datablock WheeledVehicleTire(gc_PlasmaTankTire)
{
  shapeFile = "./emptyWheel.dts";
  mass = 10;
  radius = 1;
  staticFriction = 4;
  kineticFriction = 4;
  restitution = 0.5;
  lateralForce = 18000;
  lateralDamping = 4000;
  lateralRelaxation = 0.01;
  longitudinalForce = 14000;
  longitudinalDamping = 2000;
  longitudinalRelaxation = 0.01;
};

datablock WheeledVehicleSpring(gc_PlasmaTankSpring)
{
  length = 0.5;
  force = 6000;
  damping = 1000;
  antiSwayForce = 6;
};

datablock WheeledVehicleData(gc_PlasmaTankVehicle)
{
  uiName = "Plasma Tank";
  category = "Vehicles";
  displayName = "";
  shapeFile = "./plasmatank.dts";
  emap = true;
  minMountDist = 3;
  numMountPoints = 3;
  mountThread[0] = "crouch";
  mountThread[1] = "sit";
  mountThread[2] = "sit";
  maxDamage = 400;
  destroyedLevel = 400;
  speedDamageScale = 1.04;
  collDamageThresholdVel = 20;
  collDamageMultiplier = 0.02;
  massCenter = "0 0 -0.5";
  maxSteeringAngle = 0.9;
  integration = 4;
  tireEmitter = gc_tireEmitter;
  cameraRoll = false;
  cameraMaxDist = 13;
  cameraOffset = 7.5;
  cameraLag = 0.0;
  cameraDecay = 0.75;
  cameraTilt = 0.4;
  collisionTol = 0.1;
  contactTol = 0.1;
  useEyePoint = false;
  defaultTire = gc_PlasmaTankTire;
  defaultSpring = gc_PlasmaTankSpring;
  numWheels = 6;
  mass = 400;
  density = 5;
  drag = 1.6;
  bodyFriction = 0.6;
  bodyRestitution = 0.6;
  minImpactSpeed = 10;
  softImpactSpeed = 10;
  hardImpactSpeed = 15;
  groundImpactMinSpeed = 10;
  engineTorque = 5000;
  engineBrake = 500;
  brakeTorque = 5000;
  maxWheelSpeed = 25;
  rollForce = 900;
  yawForce = 600;
  pitchForce = 1000;
  rotationalDrag = 0.2;
  maxEnergy = 100;
  jetForce = 3000;
  minJetEnergy = 30;
  jetEnergyDrain = 2;
  splash = vehicleSplash;
  splashVelocity = 4;
  splashAngle = 67;
  splashFreqMod = 300;
  splashVelEpsilon = 0.6;
  bubbleEmitTime = 1.4;
  splashEmitter[0] = vehicleFoamDropletsEmitter;
  splashEmitter[1] = vehicleFoamEmitter;
  splashEmitter[2] = vehicleBubbleEmitter;
  mediumSplashSoundVelocity = 10;
  hardSplashSoundVelocity = 20;
  exitSplashSoundVelocity = 5;
  softImpactSound = slowImpactSound;
  hardImpactSound = fastImpactSound;
  justcollided = 0;
  rideable = true;
  lookUpLimit = 1;
  lookDownLimit = 0;
  paintable = true;
  damageEmitter[0] = gc_vehicleDamageEmitter;
  damageEmitterOffset[0] = "0 -3.4 1.2";
  damageLevelTolerance[0] = 0.5;
  damageEmitter[1] = VehicleBurnEmitter;
  damageEmitterOffset[1] = "0 -3.4 1.2";
  damageLevelTolerance[1] = 0.9;
  numDmgEmitterAreas = 1;
  initialExplosionProjectile = vehicleExplosionProjectile;
  initialExplosionOffset = 1;
  burnTime = 4000;
  finalExplosionProjectile = vehicleFinalExplosionProjectile;
  finalExplosionOffset = 0.5;
  minRunOverSpeed = 4;
  runOverDamageScale = 25;
  runOverPushScale = 1.2;
  protectPassengersBurn = true;
  protectPassengersRadius = true;
  protectPassengersDirect = true;
};

//### Functions

function gc_PlasmaTankVehicle::onAdd(%this,%obj)
{
  for(%i=0;%i<%this.numWheels;%i++)
  {
    %obj.setWheelTire(%i,%this.defaultTire);
    %obj.setWheelSpring(%i,%this.defaultSpring);
  }
  %obj.setWheelSteering(0,1);
  %obj.setWheelSteering(1,1);
  %obj.setWheelSteering(4,-0.8);
  %obj.setWheelSteering(5,-0.8);
  %obj.setWheelPowered(0,true);
  %obj.setWheelPowered(1,true);
  %obj.setWheelPowered(2,true);
  %obj.setWheelPowered(3,true);
  %obj.setWheelPowered(4,true);
  %obj.setWheelPowered(5,true);
  gc_PlasmaTankEngineCheck(%obj);
  %t = new AIPlayer() { dataBlock = gc_PlasmaTankTurretPlayer; };
  MissionCleanup.add(%t);
  %obj.mountObject(%t,1);
  %obj.turret = %t;
  %obj.creationTime = getSimTime();
  if(%t.dataBlock !$= gc_PlasmaTankTurretPlayer) return;
  if(!isObject(%t)) return;
  %parent = %t.getObjectMount();
  if(!isObject(%parent)) return;
  %t.spawnBrick = %parent.spawnBrick;
  %t.brickGroup = %parent.brickGroup;
  %mg = new AIPlayer() { dataBlock = gc_PlasmaTankMGPlayer; };
  MissionCleanup.add(%mg);
  %obj.mountObject(%mg,2);
  %obj.mg = %mg;
}

function gc_PlasmaTankEngineCheck(%obj)
{
  if(!isObject(%obj)) return;
  if(vectorLen(%obj.getVelocity()) < 5)
  {
    %obj.unMountImage(2);
    %obj.unMountImage(3);
  }
  else
  {
    %obj.mountImage(gc_PlasmaTankEngineLeftImage,2);
    %obj.mountImage(gc_PlasmaTankEngineRightImage,3);
  }
  Schedule(2000,0,"gc_PlasmaTankEngineCheck",%obj);
}

function gc_PlasmaTankVehicle::onRemove(%this,%obj)
{
  if(isObject(%obj.mg)) %obj.mg.delete();
  if(isObject(%obj.turret)) %obj.turret.delete();
}

function gc_PlasmaTankTurretPlayer::onAdd(%this, %obj)
{
  %obj.lastShotTime = getSimTime() - 2000;
  parent::onAdd(%this,%obj);
}

package gc_PlasmaTankPackage
{
  function Player::Burn(%obj,%time)
  {
    if(%obj.dataBlock $= gc_PlasmaTankTurretPlayer) return;
    if(%obj.dataBlock $= gc_PlasmaTankMGPlayer) return;
    parent::Burn(%obj,%time);
  }
  function ShapeBase::setNodeColor(%obj,%node,%color)
  {
    parent::setnodecolor(%obj,%node,%color);
    if(isObject(%obj.turret)) %obj.turret.setNodeColor("ALL",%color);
    if(isObject(%obj.mg)) %obj.mg.setNodeColor("ALL",%color);
  }
  function gc_PlasmaTankVehicle::Damage(%this,%obj,%source,%pos,%amout,%type)
  {
    if(%amout < 40) %amout = 0;
    if((%obj.getDamageLevel()+%amout) >= %this.maxDamage)
    {
      if(%obj.destroyed) return;
      for(%i=0;%i<%this.numWheels;%i++) { %obj.setWheelTire(%i,emptyTire); }
      %obj.setNodeColor("ALL","0 0 0 1");
      if(isObject(%obj.mg)) %obj.mg.delete();
      if(isObject(%obj.turret)) %obj.turret.delete();
      %p = new Projectile()
      {
        dataBlock = vehicleFinalExplosionProjectile;
        initialPosition = vectorAdd(%obj.getPosition(),"0 0" SPC %this.initialExplosionOffset);
        initialVelocity = "0 0 1";
        client = %obj.lastDamageClient;
        sourceClient = %obj.lastDamageClient;
      };
      MissionCleanup.add(%p);
      if(%obj.destroyed) return;
      %obj.setDamageLevel(%this.maxDamage);
      %obj.destroyed = 1;
      %obj.schedule(%this.burnTime,"finalExplosion");
      if(isObject(%obj.spawnBrick.client.minigame)) %respawn = %obj.spawnBrick.client.minigame.vehicleReSpawnTime;
      %obj.spawnBrick.schedule(%respawn,"spawnVehicle");
    }
    else
      parent::Damage(%this,%obj,%source,%pos,%amout,%type);
  }
  function Player::emote(%obj,%emote)
  {
    if(%obj.dataBlock $= gc_PlasmaTankTurretPlayer) return;
    if(%obj.dataBlock $= gc_PlasmaTankMGPlayer) return;
    parent::emote(%obj,%emote);
  }
  function gc_PlasmaTankTurretPlayer::onDisabled(%this,%obj,%state)
  {
    %tank = %obj.getObjectMount();
    if(isObject(%tank)) %pos = vectorAdd(%obj.getObjectMount().getPosition(),"0 0" SPC %obj.getObjectMount().dataBlock.initialExplosionOffset);
    else
      %pos = %obj.getHackPosition();
    %p = new Projectile()
    {
      dataBlock = vehicleFinalExplosionProjectile;
      initialPosition = %pos;
      initialVelocity = "0 0 1";
      client = %obj.lastDamageClient;
      sourceClient = %obj.lastDamageClient;
    };
    MissionCleanup.add(%p);
    %obj.schedule(10,"delete");
    if(isObject(%tank))
    {
      %player = %obj.getMountedObject(0);
      if(isObject(%player)) %obj.getObjectMount().schedule(10,"mountObject",%player,2);
    }
    parent::onDisabled(%this,%obj,%state);
  }
  function armor::onMount(%this,%obj,%col,%slot)
  {
    parent::onMount(%this,%obj,%col,%slot);
    if(isObject(%obj.client))
    {
      if(%col.getDataBlock() == gc_PlasmaTankTurretPlayer.getId()) ServerCmdUnUseTool(%obj.client);
      if(%col.getDataBlock() == gc_PlasmaTankMGPlayer.getId()) ServerCmdUnUseTool(%obj.client);
    }
  }
  function armor::onTrigger(%this,%obj,%triggerNum,%val)
  {
    %mount = %obj.getObjectMount();
    if(isObject(%mount))
    {
      if(!%val) cancel(%obj.gc_PlasmaTankMGLoop);
      if(%mount.getDataBlock() == gc_PlasmaTankMGPlayer.getId() && %triggerNum == 0 && %val)
      %obj.gc_PlasmaTankMGFire(%val);
    }
    if(%obj.getDataBlock().getID() == gc_PlasmaTankTurretPlayer.getID()) %mount = %obj;
    if(isObject(%mount))
    {
      if(%mount.getDataBlock() == gc_PlasmaTankTurretPlayer.getId() && %triggerNum == 0 && %val)
      {
        %client = %obj.client;
        if(isObject(%client)) ServerCmdUnUseTool(%client);
        if(getSimTime() - %obj.lastShotTime < 2000) return;
        %scaleFactor = getWord(%mount.getScale(),2);
        %p = new Projectile()
        {
          dataBlock = gc_PlasmaTankShellProjectile;
          initialPosition = %mount.getSlotTransform(1);
          initialVelocity = vectorScale(%mount.getMuzzleVector(1),200);
          sourceObject = %obj;
          client = %obj.client;
          sourceSlot = 0;
          originPoint = %mount.getSlotTransform(1);
        };
        MissionCleanup.add(%p);
        %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
        %mount.mountImage(gc_PlasmaTankFireImage,1);
        %mount.playThread(2,"fire");
        serverPlay3D(gc_PlasmaTankFireSound,%obj.getPosition());
        %tank = %mount.getObjectMount();
        if(isObject(%tank))
        {
          %theVector = %mount.getEyeVector();
          %theVector = vectorAdd(%theVector,"0 0 1");
          %theVector = vectorScale(%theVector,%tank.getDataBlock().mass);
          %theVector = vectorSub(%theVector,vectorScale(%thevector,2));
          %tank.applyImpulse(getWords(%mount.getEyeTransform(),0,2),%theVector);
        }
        %obj.lastShotTime = getSimTime();
        return;
      }
    }
    parent::onTrigger(%this,%obj,%triggerNum,%val);
  }
  function Player::gc_PlasmaTankMGFire(%obj,%val)
  {
    if(!%val) { cancel(%obj.gc_PlasmaTankMGLoop); return; }
    if(!isObject(%obj.getObjectMount())) { cancel(%obj.gc_PlasmaTankMGLoop); return; }
    if(%obj.getObjectMount().getDataBlock() != gc_PlasmaTankMGPlayer.getId()) { cancel(%obj.gc_PlasmaTankMGLoop); return; }
    %client = %obj.client;
    if(isObject(%client)) ServerCmdUnUseTool(%client);
    %mount = %obj.getObjectMount();
    %scaleFactor = getWord(%mount.getScale(),2);
    %p = new Projectile()
    {
      dataBlock = gc_PlasmaTankMGProjectile;
      initialPosition = %mount.getSlotTransform(1);
      initialVelocity = MatrixMulVector(MatrixCreateFromEuler(((getRandom()-0.5)*0.04) SPC ((getRandom()-0.5)*0.04) SPC ((getRandom()-0.5)*0.04)),VectorScale(%mount.getMuzzleVector(1),150));
      sourceObject = %obj;
      client = %client;
      sourceSlot = 0;
      originPoint = %mount.getSlotTransform(1);
    };
    MissionCleanup.add(%p);
    %p.setScale(%scaleFactor SPC %scaleFactor SPC %scaleFactor);
    %mount.mountImage(gc_PlasmaTankMGFireImage,1);
    %mount.playThread(0,fire);
    serverPlay3D(gc_PlasmaTankMGFireSound,%obj.getPosition());
    %obj.gc_PlasmaTankMGLoop = %obj.schedule(120,gc_PlasmaTankMGFire,%val);
    return;
  }
};
activatepackage(gc_PlasmaTankPackage);
